<template>
  <div class="page-box" style="position: relative;">
    <el-form
      ref="formTourHouseDevelopersTypeRef"
      :model="formData"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box :item-width="350" @search="refreshFormTourHouseDevelopersType()" @reset="resetFormTourHouseDevelopersType">
        <el-form-item label="开发商名称">
          <el-input
            class="filter-item"
            v-model="formFilter.nameFilter"
            type="text"
            placeholder=""
            :clearable="true"
            :show-word-limit="false"
            maxlength=""
          />
        </el-form-item>
        <el-form-item label="是否启用">
          <el-select
            class="filter-item"
            v-model="formFilter.enableFilter"
            placeholder=""
            :clearable="true"
            :filterable="true"
            @visible-change="enableFilterWidget.onVisibleChange"
          >
            <el-option
              v-for="item in enableFilterWidgetDropdownList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
      </filter-box>
    </el-form>
    <table-box
      ref="formTourHouseDevelopersTypeTable"
      class="page-table"
      :data="formTourHouseDevelopersTypeTableWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((formTourHouseDevelopersTypeTableWidgetCurrentPage - 1) * formTourHouseDevelopersTypeTableWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="formTourHouseDevelopersTypeTableWidget.onSortChange"
      @refresh="formTourHouseDevelopersTypeTableWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onAddTourHouseDevelopersTypeClick()"
          >
          新建
        </el-button>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onExportTourHouseDevelopersTypeClick()"
          >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :on-change="onImportTourHouseDevelopersTypeClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
            >
              导入
            </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column title="序号" type="seq" :index="formTourHouseDevelopersTypeTableWidget.getTableIndex" :width="80" />
      <vxe-column title="主键" field="idDictMap.name" />
      <vxe-column title="开发商名称" field="name" />
      <vxe-column title="是否启用" field="enableDictMap.name" />
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditTourHouseDevelopersTypeClick(scope.row)"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteTourHouseDevelopersTypeClick(scope.row)"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="formTourHouseDevelopersTypeTableWidgetTotalCount"
            :current-page="formTourHouseDevelopersTypeTableWidgetCurrentPage"
            :page-size="formTourHouseDevelopersTypeTableWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="formTourHouseDevelopersTypeTableWidget.onCurrentPageChange"
            @size-change="formTourHouseDevelopersTypeTableWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formTourHouseDevelopersType',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourHouseDevelopersTypeData } from '@/api/generated/tourHouseDevelopersTypeController';
import { TourHouseDevelopersTypeController } from '@/api/generated';
import FormEditTourHouseDevelopersType from '@/pages/TourHouseDevelopors/formEditTourHouseDevelopersType.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);

const formFilter = reactive({
  // 开发商名称
  nameFilter: undefined,
  // 是否启用
  enableFilter: undefined,
});
const formFilterCopy = reactive({
  // 开发商名称
  nameFilter: undefined,
  // 是否启用
  enableFilter: undefined,
});

const onCancel = () => {
  layoutStore.removeCachePage(route.name as string);
  route.meta.refreshParentCachedPage = true;
  router.go(-1);
};

const onResume = () => {
  refreshFormTourHouseDevelopersType();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadFormTourHouseDevelopersTypeTableWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
    tourHouseDevelopersTypeDtoFilter: {
      name: formFilter.nameFilter,
      enable: formFilter.enableFilter,
    }
  };
  return new Promise((resolve, reject) => {
    TourHouseDevelopersTypeController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadFormTourHouseDevelopersTypeTableVerify = () => {
  formFilterCopy.nameFilter = formFilter.nameFilter;
  formFilterCopy.enableFilter = formFilter.enableFilter;
  return true;
};
/**
 * 新建
 */
const onAddTourHouseDevelopersTypeClick = (row?: TourHouseDevelopersTypeData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditTourHouseDevelopersType, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourHouseDevelopersTypeTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditTourHouseDevelopersTypeClick = (row?: TourHouseDevelopersTypeData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditTourHouseDevelopersType, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourHouseDevelopersTypeTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportTourHouseDevelopersTypeClick = (row?: TourHouseDevelopersTypeData) => {
  let params: ANY_OBJECT = {
  };

  TourHouseDevelopersTypeController.export(params, '表格组件.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 导入
 */
const onImportTourHouseDevelopersTypeClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  TourHouseDevelopersTypeController.import(params).then(res => {
    ElMessage.success('导入成功');
    formTourHouseDevelopersTypeTableWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 删除
 */
const onDeleteTourHouseDevelopersTypeClick = (row?: TourHouseDevelopersTypeData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  ElMessageBox.confirm('是否删除此记录？').then(res => {
    TourHouseDevelopersTypeController.delete(params).then(res => {
      ElMessage.success('删除成功');
      formTourHouseDevelopersTypeTableWidget.refreshTable(false, 1);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const formTourHouseDevelopersTypeTableOptions: TableOptions<TourHouseDevelopersTypeData> = {
  loadTableData: loadFormTourHouseDevelopersTypeTableWidgetData,
  verifyTableParameter: loadFormTourHouseDevelopersTypeTableVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const formTourHouseDevelopersTypeTable = ref();
const formTourHouseDevelopersTypeTableWidget = useTable(formTourHouseDevelopersTypeTableOptions);
const {
  dataList: formTourHouseDevelopersTypeTableWidgetDataList,
  currentPage: formTourHouseDevelopersTypeTableWidgetCurrentPage,
  pageSize: formTourHouseDevelopersTypeTableWidgetPageSize,
  totalCount: formTourHouseDevelopersTypeTableWidgetTotalCount,
} = formTourHouseDevelopersTypeTableWidget;
/**
 * 是否启用下拉数据获取函数
 */
const loadEnableFilterDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Enable.getList(),
  });
};
// 是否启用配置参数
const enableFilterOptions: DropdownOptions<DictData> = {
  loadData: loadEnableFilterDropdownList,
  isTree: false,
};
// 是否启用下拉组件
const enableFilterWidget = useDropdown(enableFilterOptions);
const { dropdownList: enableFilterWidgetDropdownList } = enableFilterWidget
const refreshFormTourHouseDevelopersType = () => {
  // 刷新段落
  formTourHouseDevelopersTypeTableWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormTourHouseDevelopersType = () => {
  formFilter.nameFilter = undefined;
  formFilterCopy.nameFilter = undefined;
  formFilter.enableFilter = undefined;
  formFilterCopy.enableFilter = undefined;
  refreshFormTourHouseDevelopersType();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormTourHouseDevelopersType();
};
const formInit = () => {
  enableFilterWidget.onVisibleChange(true).catch(e => {console.error(e)});
  refreshFormTourHouseDevelopersType();
};

onMounted(() => {
  formInit();
});
</script>